/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.45 from the
 * contents of Krb5.xs. Do not edit this file, edit Krb5.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Authen/Krb5.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* We currently provide some private functions and probably shouldn't. */
#define KRB5_PRIVATE 1
#include <krb5.h>

/* Recent versions of Kerberos include com_err on their own.  Uncomment if you
 * have an older version and the complier complains about missing headers.
 */
/* #include <com_err.h> */

#include <errno.h>
#include "krb5_constants.c"

#ifdef __cplusplus
}
#endif

/* change this if 10 hours doesn't suit you */
#define KRB5_DEFAULT_LIFE 60*60*10

typedef krb5_ccache		Authen__Krb5__Ccache;
typedef krb5_principal		Authen__Krb5__Principal;
typedef krb5_auth_context	Authen__Krb5__AuthContext;
typedef krb5_rcache		Authen__Krb5__Rcache;
typedef krb5_creds		*Authen__Krb5__Creds;
typedef krb5_ap_rep_enc_part	*Authen__Krb5__ApRepEncPart;
typedef krb5_ticket		*Authen__Krb5__Ticket;
typedef krb5_keytab		Authen__Krb5__Keytab;
typedef krb5_enc_tkt_part	*Authen__Krb5__EncTktPart;
typedef krb5_error		*Authen__Krb5__Error;
typedef krb5_address		*Authen__Krb5__Address;
typedef krb5_keyblock		*Authen__Krb5__Keyblock;
typedef krb5_keytab_entry	*Authen__Krb5__KeytabEntry;
typedef krb5_kt_cursor          *Authen__Krb5__KeytabCursor;
typedef krb5_cc_cursor          *Authen__Krb5__CcacheCursor;
typedef krb5_keyblock		*Authen__Krb5__KeyBlock;

static krb5_context context = NULL;
static krb5_error_code err;
static krb5_keytab_entry keytab_entry_init;

/*
 * The following three routines implement a "safehouse" for nested Kerberos
 * data structures which shouldn't be freed before their parent data
 * structures are freed.  Without this, "Bad free() ignored" errors as well
 * as core dumps could occur when the parent structures are eventually freed.
 *
 * If a method returns a newly allocated object, it calls can_free() to
 * register the object as "freeable," since the memory was not in use
 * beforehand.  This module will only free objects that have been registered
 * with can_free(), and lets Kerberos free the others.
 *
 * Doing it the other way (registering objects which *shouldn't* be freed)
 * is more complicated than it first seems, so I did it this way.
 */


HV *free_hash = NULL; /* might as well take advantage of Perl! */

void can_free(SV *sv)
{
	char key[80];

	sprintf(key,"%p",sv);
	if (!free_hash) free_hash = newHV();
	hv_store(free_hash,key,strlen(key),&PL_sv_yes,0);
}

int should_free(SV *sv)
{
	char key[80];

	if (!free_hash) return 0;
	sprintf(key,"%p",sv);
	return hv_exists(free_hash,key,strlen(key));
}

void freed(SV *sv)
{
	char key[80];

	if (!free_hash) return;
	sprintf(key,"%p",sv);
	hv_delete(free_hash,key,strlen(key),G_DISCARD);
}


#line 104 "lib/Authen/Krb5.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 248 "lib/Authen/Krb5.c"

XS_EUPXS(XS_Authen__Krb5_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_error)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "e = 0");
    {
	krb5_error_code	e;

	if (items < 1)
	    e = 0;
	else {
	    e = (int)SvIV(ST(0))
;
	}
#line 108 "lib/Authen/Krb5.xs"
	if (e) {
		ST(0) = sv_2mortal(newSVpv((char *)error_message(e), 0));
	}
	else {
		ST(0) = sv_2mortal(newSVpv((char *)error_message(err), 0));
		(void) SvUPGRADE(ST(0), SVt_PVIV);
		SvIVX(ST(0)) = err;
		SvIOK_on(ST(0));
	}
#line 297 "lib/Authen/Krb5.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_init_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_init_context)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 122 "lib/Authen/Krb5.xs"
	if (context) croak("Authen::Krb5 already initialized");
	err = krb5_init_context(&context);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 315 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_free_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_free_context)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 131 "lib/Authen/Krb5.xs"
	if (!context) croak("Authen::Krb5 not yet initialized");
	krb5_free_context(context);
        context = NULL;
#line 332 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_init_ets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_init_ets)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 139 "lib/Authen/Krb5.xs"
#if KRB5_DEPRECATED
	krb5_init_ets(context);
#endif /* KRB5_DEPRECATED */
	XSRETURN_YES;
#line 350 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_get_default_realm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_default_realm)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 148 "lib/Authen/Krb5.xs"
	char *realm;

#line 368 "lib/Authen/Krb5.c"
#line 151 "lib/Authen/Krb5.xs"
	err = krb5_get_default_realm(context,&realm);
	if (err || !realm) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(realm,strlen(realm))));
	Safefree(realm);
#line 374 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5_get_host_realm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_host_realm)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "host");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	host = (char *)SvPV_nolen(ST(0))
;
#line 161 "lib/Authen/Krb5.xs"
	char **realmlist;
	int i;

#line 396 "lib/Authen/Krb5.c"
#line 165 "lib/Authen/Krb5.xs"
	err = krb5_get_host_realm(context,host,&realmlist);
	if (err || !realmlist) XSRETURN_UNDEF;
	for (i = 0; realmlist[i]; i++) {
		XPUSHs(sv_2mortal(newSVpv(realmlist[i],
			strlen(realmlist[i]))));
	}
	krb5_free_host_realm(context,realmlist);
#line 405 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5_build_principal_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_build_principal_ext)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	Authen__Krb5__Principal	p;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 178 "lib/Authen/Krb5.xs"
	err = krb5_build_principal_ext(context, &RETVAL,
		krb5_princ_realm(context, p)->length,
		krb5_princ_realm(context, p)->data,
		KRB5_TGS_NAME_SIZE, KRB5_TGS_NAME,
		krb5_princ_realm(context, p)->length,
		krb5_princ_realm(context, p)->data,
		0);

	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 446 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_parse_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_parse_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__Principal	RETVAL;
#line 198 "lib/Authen/Krb5.xs"
	err = krb5_parse_name(context,name,&RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 474 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_sname_to_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_sname_to_principal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hostname, sname, type");
    {
	char *	hostname = (char *)SvPV_nolen(ST(0))
;
	char *	sname = (char *)SvPV_nolen(ST(1))
;
	krb5_int32	type = (int)SvIV(ST(2))
;
	Authen__Krb5__Principal	RETVAL;
#line 213 "lib/Authen/Krb5.xs"
	err = krb5_sname_to_principal(context,hostname,sname,type,&RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 506 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_cc_resolve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_cc_resolve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string_name");
    {
	char *	string_name = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__Ccache	RETVAL;
#line 226 "lib/Authen/Krb5.xs"
	err = krb5_cc_resolve(context, string_name, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 534 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Ccache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_cc_default_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_cc_default_name)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 238 "lib/Authen/Krb5.xs"
	RETVAL = (char *)krb5_cc_default_name(context);

#line 558 "lib/Authen/Krb5.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_cc_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_cc_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Authen__Krb5__Ccache	RETVAL;
#line 247 "lib/Authen/Krb5.xs"
	err = krb5_cc_default(context, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 581 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Ccache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_kt_resolve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_kt_resolve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string_name");
    {
	char *	string_name = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__Keytab	RETVAL;
#line 260 "lib/Authen/Krb5.xs"
	err = krb5_kt_resolve(context, string_name, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 609 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Keytab", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_kt_default_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_kt_default_name)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 271 "lib/Authen/Krb5.xs"
        char name[BUFSIZ];
        err = krb5_kt_default_name(context, name, sizeof name - 1);
	if (err)
                XSRETURN_UNDEF;
        name[sizeof name - 1] = '\0';
	RETVAL = newSVpv(name, 0);

#line 637 "lib/Authen/Krb5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_kt_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_kt_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Authen__Krb5__Keytab	RETVAL;
#line 284 "lib/Authen/Krb5.xs"
        err = krb5_kt_default(context, &RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 658 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Keytab", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_kt_read_service_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_kt_read_service_key)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "name, principal, kvno = 0, enctype = 0");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__Principal	principal;
	krb5_kvno	kvno;
	krb5_enctype	enctype;
	Authen__Krb5__Keyblock	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	}
;

	if (items < 3)
	    kvno = 0;
	else {
	    kvno = (unsigned int)SvUV(ST(2))
;
	}

	if (items < 4)
	    enctype = 0;
	else {
	    enctype = (int)SvIV(ST(3))
;
	}
#line 299 "lib/Authen/Krb5.xs"
        err = krb5_kt_read_service_key(context, name, principal, kvno, enctype,
            &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 716 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Keyblock", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_get_init_creds_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_init_creds_password)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "client, password, service = NULL");
    {
	Authen__Krb5__Principal	client;
	char *	password = (char *)SvPV_nolen(ST(1))
;
	char *	service;
#line 315 "lib/Authen/Krb5.xs"
	krb5_get_init_creds_opt opt;

#line 742 "lib/Authen/Krb5.c"
	Authen__Krb5__Creds	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	}
;

	if (items < 3)
	    service = NULL;
	else {
	    service = (char *)SvPV_nolen(ST(2))
;
	}
#line 318 "lib/Authen/Krb5.xs"
	if (service != NULL && service[0] == '\0') service = NULL;
	RETVAL = calloc(1, sizeof(krb5_creds));
	if (RETVAL == NULL) {
		err = errno;
		XSRETURN_UNDEF;
	}
	krb5_get_init_creds_opt_init(&opt);

	err = krb5_get_init_creds_password(context, RETVAL, client, password,
		NULL, NULL, 0, service, &opt);
	if (err) {
		free(RETVAL);
		XSRETURN_UNDEF;
	}
	can_free((SV *)RETVAL);

#line 780 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Creds", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_get_init_creds_keytab); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_init_creds_keytab)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "client, keytab, service = NULL");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Keytab	keytab;
	char *	service;
#line 344 "lib/Authen/Krb5.xs"
	krb5_get_init_creds_opt opt;

#line 805 "lib/Authen/Krb5.c"
	Authen__Krb5__Creds	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	}
;

	if (ST(1) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (items < 3)
	    service = NULL;
	else {
	    service = (char *)SvPV_nolen(ST(2))
;
	}
#line 347 "lib/Authen/Krb5.xs"
	if (service != NULL && service[0] == '\0') service = NULL;
	RETVAL = calloc(1, sizeof(krb5_creds));
	if (RETVAL == NULL) {
		err = errno;
		XSRETURN_UNDEF;
	}
	krb5_get_init_creds_opt_init(&opt);

	err = krb5_get_init_creds_keytab(context, RETVAL, client, keytab, 0,
		service, &opt);
	if (err) {
		free(RETVAL);
		XSRETURN_UNDEF;
	}
	can_free((SV *)RETVAL);

#line 855 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Creds", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_get_in_tkt_with_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_in_tkt_with_password)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "client, server, password, cc");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	char *	password = (char *)SvPV_nolen(ST(2))
;
	Authen__Krb5__Ccache	cc;
#line 378 "lib/Authen/Krb5.xs"
	krb5_creds cr;
	krb5_get_init_creds_opt opt;
	char *service;

#line 884 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	}
;

	if (ST(1) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	}
;

	if (ST(3) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 383 "lib/Authen/Krb5.xs"
	memset((char *)&cr,0,sizeof(krb5_creds));
	krb5_get_init_creds_opt_init(&opt);
	err = krb5_unparse_name(context, server, &service);
	if (err) XSRETURN_UNDEF;

	err = krb5_get_init_creds_password(context, &cr, client, password,
		NULL, NULL, 0, service, &opt);
	free(service);
	if (err) XSRETURN_UNDEF;

	err = krb5_cc_initialize(context, cc, client);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	err = krb5_cc_store_cred(context, cc, &cr);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	krb5_free_cred_contents(context, &cr);

	XSRETURN_YES;
#line 945 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_get_in_tkt_with_keytab); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_in_tkt_with_keytab)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "client, server, keytab, cc");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__Ccache	cc;
#line 415 "lib/Authen/Krb5.xs"
	krb5_creds cr;
	krb5_get_init_creds_opt opt;
	char *service;

#line 967 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	}
;

	if (ST(1) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	}
;

	if (ST(2) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (ST(3) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 420 "lib/Authen/Krb5.xs"
	memset(&cr,0,sizeof(krb5_creds));
	krb5_get_init_creds_opt_init(&opt);
	err = krb5_unparse_name(context, server, &service);
	if (err) XSRETURN_UNDEF;

	err = krb5_get_init_creds_keytab(context, &cr, client, keytab, 0,
		service, &opt);
	free(service);
	if (err) XSRETURN_UNDEF;

	err = krb5_cc_initialize(context, cc, client);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	err = krb5_cc_store_cred(context, cc, &cr);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	krb5_free_cred_contents(context, &cr);

	XSRETURN_YES;
#line 1040 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_mk_req); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_mk_req)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "auth_context, ap_req_options, service, hostname, in, cc");
    {
	Authen__Krb5__AuthContext	auth_context;
	krb5_flags	ap_req_options = (int)SvIV(ST(1))
;
	char *	service = (char *)SvPV_nolen(ST(2))
;
	char *	hostname = (char *)SvPV_nolen(ST(3))
;
	SV *	in = ST(4)
;
	Authen__Krb5__Ccache	cc;
#line 454 "lib/Authen/Krb5.xs"
	krb5_data in_data, out_data;

#line 1066 "lib/Authen/Krb5.c"
	SV *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(5) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(5), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(5)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 457 "lib/Authen/Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_mk_req(context,&auth_context,ap_req_options,service,hostname,
		&in_data,cc,&out_data);
	if (err) XSRETURN_UNDEF;
	RETVAL = newSVpv(out_data.data,out_data.length);

#line 1099 "lib/Authen/Krb5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_rd_req); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_rd_req)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "auth_context, in, server, keytab=0");
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1)
;
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
#line 474 "lib/Authen/Krb5.xs"
	krb5_data in_data;
	krb5_ticket *t;

#line 1123 "lib/Authen/Krb5.c"
	Authen__Krb5__Ticket	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(2) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	}
;

	if (items < 4)
	    keytab = 0;
	else {
	    if (ST(3) == &PL_sv_undef) {
		    keytab = 0;
	    }
	    else if (sv_isa(ST(3), "Authen::Krb5::Keytab")) {
		    IV tmp = SvIV((SV*)SvRV(ST(3)));
		    keytab = (Authen__Krb5__Keytab) tmp;
	    }
	    else {
		    croak("keytab is not of type Authen::Krb5::Keytab");
	    }
;
	}
#line 478 "lib/Authen/Krb5.xs"
	if (!New(0,t,1,krb5_ticket)) XSRETURN_UNDEF;
	in_data.data = SvPV(in,in_data.length);
	err = krb5_rd_req(context,&auth_context,&in_data,server,keytab,
		NULL,&t);
	if (err) XSRETURN_UNDEF;
	RETVAL = t;

	can_free((SV *)RETVAL);

#line 1175 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Ticket", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_gen_portaddr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_gen_portaddr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "addr, port");
    {
	Authen__Krb5__Address	addr;
	unsigned short	port = (unsigned short)SvUV(ST(1))
;
	Authen__Krb5__Address	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	}
;
#line 496 "lib/Authen/Krb5.xs"
	err = krb5_gen_portaddr(context,addr,(krb5_pointer)&port,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 1214 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Address", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_genaddrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_genaddrs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "auth_context, fh, flags");
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	krb5_flags	flags = (int)SvIV(ST(2))
;
#line 509 "lib/Authen/Krb5.xs"
	int fd;

#line 1241 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 512 "lib/Authen/Krb5.xs"
	fd = fileno(fh);
	err = krb5_auth_con_genaddrs(context,auth_context,fd,flags);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;  
#line 1259 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5_gen_replay_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_gen_replay_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "addr, uniq");
    {
	Authen__Krb5__Address	addr;
	char *	uniq = (char *)SvPV_nolen(ST(1))
;
	char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	}
;
#line 523 "lib/Authen/Krb5.xs"
	err = krb5_gen_replay_name(context,addr,uniq,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 1293 "lib/Authen/Krb5.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_mk_priv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_mk_priv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "auth_context, in");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1)
;
#line 535 "lib/Authen/Krb5.xs"
	krb5_data in_data, out_data;

#line 1317 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 538 "lib/Authen/Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_mk_priv(context,auth_context,&in_data,&out_data,NULL);
	if (err) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(out_data.data,out_data.length)));
	/* krb5_free_data(context,&out_data); */
#line 1336 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5_rd_priv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_rd_priv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "auth_context, in");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1)
;
#line 550 "lib/Authen/Krb5.xs"
	krb5_data in_data, out_data;

#line 1358 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 553 "lib/Authen/Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_rd_priv(context,auth_context,&in_data,&out_data,NULL);
	if (err) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(out_data.data,out_data.length)));
#line 1376 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5_get_server_rcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_get_server_rcache)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "piece");
    {
	SV *	piece = ST(0)
;
#line 563 "lib/Authen/Krb5.xs"
	krb5_data rc_data;

#line 1395 "lib/Authen/Krb5.c"
	Authen__Krb5__Rcache	RETVAL;
#line 566 "lib/Authen/Krb5.xs"
	rc_data.data=SvPV(piece,rc_data.length);
	err = krb5_get_server_rcache(context,&rc_data,&RETVAL);

	if (err) XSRETURN_UNDEF;

#line 1403 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Rcache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5_sendauth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_sendauth)
{
    dVAR; dXSARGS;
    if (items != 9)
       croak_xs_usage(cv,  "auth_context, fh, version, client, server, options, in, in_creds, cc");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	char *	version = (char *)SvPV_nolen(ST(2))
;
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	int	options = (int)SvIV(ST(5))
;
	SV *	in = ST(6)
;
	Authen__Krb5__Creds	in_creds;
	Authen__Krb5__Ccache	cc;
#line 587 "lib/Authen/Krb5.xs"
	krb5_data in_data;
	krb5_creds *out_creds = NULL;
	int fd;

#line 1442 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(3) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	}
;

	if (ST(4) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(4), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(4)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	}
;

	if (ST(7) == &PL_sv_undef) {
		in_creds = 0;
	}
	else if (sv_isa(ST(7), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(7)));
		in_creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("in_creds is not of type Authen::Krb5::Creds");
	}
;

	if (ST(8) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(8), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(8)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 592 "lib/Authen/Krb5.xs"
	fd = fileno(fh);
	in_data.data = SvPV(in,in_data.length);
	err = krb5_sendauth(context,&auth_context,&fd,version,client,server,
		options,&in_data,in_creds,cc,NULL,NULL,&out_creds);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 1510 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5_recvauth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5_recvauth)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "auth_context, fh, version, server, keytab");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	char *	version = (char *)SvPV_nolen(ST(2))
;
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
#line 608 "lib/Authen/Krb5.xs"
	krb5_ticket *ticket = NULL;
	int fd;

#line 1537 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(3) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	}
;

	if (ST(4) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(4), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(4)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;
#line 612 "lib/Authen/Krb5.xs"
	fd = fileno(fh);
	err = krb5_recvauth(context,&auth_context,&fd,version,server,0,
		keytab,&ticket);
	if (err) XSRETURN_UNDEF;
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0),"Authen::Krb5::Ticket",(void*)ticket);
	XSRETURN(1);
#line 1582 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5__Principal_realm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Principal_realm)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 628 "lib/Authen/Krb5.xs"
	ST(0) = sv_2mortal(newSVpv(p->realm.data,p->realm.length));
#line 1611 "lib/Authen/Krb5.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Principal_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Principal_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	Authen__Krb5__Principal	p;
	krb5_int32	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 635 "lib/Authen/Krb5.xs"
	RETVAL = p->type;

#line 1642 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Principal_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Principal_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 645 "lib/Authen/Krb5.xs"
	if (p->length > 0) {
		int len = p->length;
		krb5_data *data;

		EXTEND(sp,len);
		for (data = p->data; len--; data++) {
			PUSHs(sv_2mortal(newSVpv(data->data,data->length)));
		}
	}
#line 1682 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5__Principal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Principal_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 660 "lib/Authen/Krb5.xs"
	if (p && should_free((SV *)p)) {
		krb5_free_principal(context,p);
		freed((SV *)p);
	}
#line 1714 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ccache_initialize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_initialize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cc, p");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;

	if (ST(1) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	}
;
#line 674 "lib/Authen/Krb5.xs"
	err = krb5_cc_initialize(context, cc, p);
	if (err) XSRETURN_UNDEF;
	else {
		can_free((SV *)cc);
		XSRETURN_YES;
	}
#line 1760 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ccache_store_cred); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_store_cred)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cc, creds");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Creds	creds;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;

	if (ST(1) == &PL_sv_undef) {
		creds = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("creds is not of type Authen::Krb5::Creds");
	}
;
#line 687 "lib/Authen/Krb5.xs"
	err = krb5_cc_store_cred(context, cc, creds);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 1803 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ccache_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cc");
    {
	Authen__Krb5__Ccache	cc;
	const char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 696 "lib/Authen/Krb5.xs"
	RETVAL = krb5_cc_get_name(context, cc);

#line 1834 "lib/Authen/Krb5.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ccache_get_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_get_principal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cc");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 706 "lib/Authen/Krb5.xs"
	err = krb5_cc_get_principal(context, cc, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 1870 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ccache_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cc");
    {
	Authen__Krb5__Ccache	cc;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 719 "lib/Authen/Krb5.xs"
	if (!should_free((SV*)cc)) XSRETURN_UNDEF;

	err = krb5_cc_destroy(context, cc);
	if (err) {
		XSRETURN_UNDEF;
	}
	else {
		freed((SV*)cc);
		XSRETURN_YES;
	}
#line 1913 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ccache_start_seq_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_start_seq_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cc");
    {
	Authen__Krb5__Ccache	cc;
	krb5_cc_cursor *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 735 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_cc_cursor))
		XSRETURN_UNDEF;
        err = krb5_cc_start_seq_get(context, cc, RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 1947 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "krb5_cc_cursorPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ccache_next_cred); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_next_cred)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cc, cursor");
    {
	krb5_cc_cursor *	cursor;
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Creds	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_cc_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_cc_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_cc_cursorPtr");
	}
;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 750 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_creds))
		XSRETURN_UNDEF;
        err = krb5_cc_next_cred(context, cc, cursor, RETVAL);
	if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 2001 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Creds", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ccache_end_seq_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_end_seq_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cc, cursor");
    {
	Authen__Krb5__Ccache	cc;
	krb5_cc_cursor *	cursor;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_cc_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_cc_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_cc_cursorPtr");
	}
;
#line 766 "lib/Authen/Krb5.xs"
        err = krb5_cc_end_seq_get(context, cc, cursor);
        if (err)
                XSRETURN_UNDEF;
        XSRETURN_YES;
#line 2051 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ccache_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ccache_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cc");
    {
	Authen__Krb5__Ccache	cc;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	}
;
#line 776 "lib/Authen/Krb5.xs"
	if (should_free((SV *)cc)) {
		krb5_cc_close(context, cc);
		freed((SV *)cc);
	}
#line 2082 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__KeyBlock_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeyBlock_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kb");
    {
	Authen__Krb5__KeyBlock	kb;
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	}
;
#line 788 "lib/Authen/Krb5.xs"
	RETVAL = kb->length;

#line 2113 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeyBlock_contents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeyBlock_contents)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__KeyBlock	kb;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	}
;
#line 798 "lib/Authen/Krb5.xs"
	/* sv_2mortal here causes 'Attempt to free unreferenced scalar' later */
	XPUSHs(newSVpvn((char*)(kb->contents), kb->length));
#line 2146 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5__KeyBlock_enctype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeyBlock_enctype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kb");
    {
	Authen__Krb5__KeyBlock	kb;
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	}
;
#line 806 "lib/Authen/Krb5.xs"
	RETVAL = (int)kb->enctype;

#line 2178 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeyBlock_enctype_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeyBlock_enctype_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Authen__Krb5__KeyBlock	kb;
#line 816 "lib/Authen/Krb5.xs"
	char buf[256];

#line 2199 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	}
;
#line 819 "lib/Authen/Krb5.xs"
	err = krb5_enctype_to_string(kb->enctype, buf, 255);
	if (err) {
		XSRETURN_UNDEF;
	}
	XPUSHs(newSVpv(buf, 0));
#line 2218 "lib/Authen/Krb5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Authen__Krb5__KeyBlock_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeyBlock_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kb");
    {
	Authen__Krb5__KeyBlock	kb;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	}
;
#line 830 "lib/Authen/Krb5.xs"
	if (kb && should_free((SV *)kb)) {
		krb5_free_keyblock(context,kb);
		freed((SV *)kb);
	}
#line 2250 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__AuthContext	RETVAL;
#line 842 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_init(context, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 2272 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::AuthContext", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_getflags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_getflags)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "auth_context");
    {
	Authen__Krb5__AuthContext	auth_context;
#line 855 "lib/Authen/Krb5.xs"
	krb5_int32 flags;

#line 2295 "lib/Authen/Krb5.c"
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 858 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_getflags(context,auth_context,&flags);
	RETVAL = (int)flags;

#line 2314 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_setflags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_setflags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "auth_context, flags");
    {
	Authen__Krb5__AuthContext	auth_context;
	krb5_int32	flags = (int)SvIV(ST(1))
;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 870 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_setflags(context,auth_context,flags);

	if(err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2349 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_getrcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_getrcache)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "auth_context");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Rcache	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 880 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_getrcache(context,auth_context,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 2380 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Rcache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_setrcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_setrcache)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "auth_context, rc");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Rcache	rc;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(1) == &PL_sv_undef) {
		rc = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Rcache")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		rc = (Authen__Krb5__Rcache) tmp;
	}
	else {
		croak("rc is not of type Authen::Krb5::Rcache");
	}
;
#line 892 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_setrcache(context,auth_context,rc);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2429 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_getaddrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_getaddrs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "auth_context");
    {
	Authen__Krb5__AuthContext	auth_context;
#line 901 "lib/Authen/Krb5.xs"
	krb5_address *local, *remote;

#line 2446 "lib/Authen/Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 904 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_getaddrs(context,auth_context,&local,&remote);
	if (err) XSRETURN_EMPTY;

	ST(0) = sv_newmortal();
	ST(1) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Address", (void*)local);
	sv_setref_pv(ST(1), "Authen::Krb5::Address", (void*)remote);
	XSRETURN(2);
#line 2468 "lib/Authen/Krb5.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_setaddrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_setaddrs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "auth_context, laddr, raddr");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Address	laddr;
	Authen__Krb5__Address	raddr;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(1) == &PL_sv_undef) {
		laddr = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		laddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("laddr is not of type Authen::Krb5::Address");
	}
;

	if (ST(2) == &PL_sv_undef) {
		raddr = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		raddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("raddr is not of type Authen::Krb5::Address");
	}
;
#line 920 "lib/Authen/Krb5.xs"
	if (!SvOK((SV*)ST(1))) laddr = NULL;
	if (!SvOK((SV*)ST(2))) raddr = NULL;
	err = krb5_auth_con_setaddrs(context,auth_context,laddr,raddr);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2526 "lib/Authen/Krb5.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_setports); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_setports)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "auth_context, laddr, raddr");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Address	laddr;
	Authen__Krb5__Address	raddr;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;

	if (ST(1) == &PL_sv_undef) {
		laddr = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		laddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("laddr is not of type Authen::Krb5::Address");
	}
;

	if (ST(2) == &PL_sv_undef) {
		raddr = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		raddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("raddr is not of type Authen::Krb5::Address");
	}
;
#line 933 "lib/Authen/Krb5.xs"
	if (!SvOK((SV*)ST(1))) laddr = NULL;
	if (!SvOK((SV*)ST(2))) raddr = NULL;
	err = krb5_auth_con_setports(context,auth_context,laddr,raddr);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2584 "lib/Authen/Krb5.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_getkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_getkey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "auth_context");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__KeyBlock	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 944 "lib/Authen/Krb5.xs"
	err = krb5_auth_con_getkey(context, auth_context, &RETVAL);
	if (err) XSRETURN_UNDEF;
	can_free((SV *)RETVAL);

#line 2616 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::KeyBlock", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__AuthContext_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__AuthContext_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "auth_context");
    {
	Authen__Krb5__AuthContext	auth_context;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	}
;
#line 956 "lib/Authen/Krb5.xs"
	if (auth_context) {
		krb5_auth_con_free(context, auth_context);
		freed((SV *)auth_context);
	}
#line 2653 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Ticket_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ticket_server)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	Authen__Krb5__Ticket	t;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	}
;
#line 968 "lib/Authen/Krb5.xs"
	RETVAL = t->server;

#line 2683 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ticket_enc_part2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ticket_enc_part2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	Authen__Krb5__Ticket	t;
	Authen__Krb5__EncTktPart	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	}
;
#line 978 "lib/Authen/Krb5.xs"
	RETVAL = t->enc_part2;

#line 2719 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::EncTktPart", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Ticket_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Ticket_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "t");
    {
	Authen__Krb5__Ticket	t;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	}
;
#line 988 "lib/Authen/Krb5.xs"
	if (t) {
		krb5_free_ticket(context,t);
		freed((SV *)t);
	}
#line 2756 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__EncTktPart_client); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__EncTktPart_client)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "etp");
    {
	Authen__Krb5__EncTktPart	etp;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		etp = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::EncTktPart")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		etp = (Authen__Krb5__EncTktPart) tmp;
	}
	else {
		croak("etp is not of type Authen::Krb5::EncTktPart");
	}
;
#line 1000 "lib/Authen/Krb5.xs"
	RETVAL = etp->client;

#line 2786 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__EncTktPart_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__EncTktPart_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "etp");
    {
	Authen__Krb5__EncTktPart	etp;

	if (ST(0) == &PL_sv_undef) {
		etp = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::EncTktPart")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		etp = (Authen__Krb5__EncTktPart) tmp;
	}
	else {
		croak("etp is not of type Authen::Krb5::EncTktPart");
	}
;
#line 1010 "lib/Authen/Krb5.xs"
	if (etp && should_free((SV *)etp)) {
		krb5_free_enc_tkt_part(context,etp);
		freed((SV *)etp);
	}
#line 2823 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Address_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Address_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, addrtype, contents");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	unsigned int	addrtype = (unsigned int)SvUV(ST(1))
;
	SV *	contents = ST(2)
;
	Authen__Krb5__Address	RETVAL;
#line 1024 "lib/Authen/Krb5.xs"
	if (!New(0,RETVAL,1,krb5_address)) XSRETURN_UNDEF;
	RETVAL->addrtype = addrtype;
	RETVAL->contents = (krb5_octet *)SvPV(contents,RETVAL->length);

#line 2848 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Address", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Address_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Address_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "addr");
    {
	Authen__Krb5__Address	addr;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	}
;
#line 1036 "lib/Authen/Krb5.xs"
	if (addr && should_free((SV *)addr)) {
		krb5_free_address(context,addr);
		freed((SV *)addr);
	}
#line 2885 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Keyblock_enctype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keyblock_enctype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keyblock");
    {
	Authen__Krb5__Keyblock	keyblock;
	krb5_enctype	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	}
;
#line 1049 "lib/Authen/Krb5.xs"
        RETVAL = keyblock->enctype;

#line 2916 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keyblock_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keyblock_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keyblock");
    {
	Authen__Krb5__Keyblock	keyblock;
	unsigned int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	}
;
#line 1059 "lib/Authen/Krb5.xs"
        RETVAL = keyblock->length;

#line 2949 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keyblock_contents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keyblock_contents)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keyblock");
    {
	Authen__Krb5__Keyblock	keyblock;
	SV *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	}
;
#line 1069 "lib/Authen/Krb5.xs"
	if (keyblock->contents == NULL)
		XSRETURN_UNDEF;
	RETVAL = newSVpv((char *) keyblock->contents, keyblock->length);

#line 2983 "lib/Authen/Krb5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keyblock_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keyblock_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keyblock");
    {
	Authen__Krb5__Keyblock	keyblock;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	}
;
#line 1081 "lib/Authen/Krb5.xs"
	if (keyblock->contents) {
		memset(keyblock->contents, 0, keyblock->length);
		free(keyblock->contents);
		keyblock->contents = NULL;
	}
#line 3017 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Keytab_add_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_add_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keytab, entry");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	entry;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (ST(1) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1095 "lib/Authen/Krb5.xs"
        err = krb5_kt_add_entry(context, keytab, entry);
	if (err)
                XSRETURN_UNDEF;
	XSRETURN_YES;
#line 3061 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Keytab_end_seq_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_end_seq_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keytab, cursor");
    {
	Authen__Krb5__Keytab	keytab;
	krb5_kt_cursor *	cursor;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_kt_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_kt_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_kt_cursorPtr");
	}
;
#line 1106 "lib/Authen/Krb5.xs"
        err = krb5_kt_end_seq_get(context, keytab, cursor);
        if (err)
                XSRETURN_UNDEF;
        XSRETURN_YES;
#line 3105 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Keytab_get_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_get_entry)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "keytab, principal, vno = 0, enctype = 0");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__Principal	principal;
	krb5_kvno	vno;
	krb5_enctype	enctype;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	}
;

	if (items < 3)
	    vno = 0;
	else {
	    vno = (unsigned int)SvUV(ST(2))
;
	}

	if (items < 4)
	    enctype = 0;
	else {
	    enctype = (int)SvIV(ST(3))
;
	}
#line 1119 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        err = krb5_kt_get_entry(context, keytab, principal, vno, enctype,
            RETVAL);
	if (err)
		XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3170 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::KeytabEntry", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keytab_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keytab");
    {
	Authen__Krb5__Keytab	keytab;
#line 1135 "lib/Authen/Krb5.xs"
        char name[MAX_KEYTAB_NAME_LEN+1];

#line 3193 "lib/Authen/Krb5.c"
	SV *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;
#line 1138 "lib/Authen/Krb5.xs"
        err = krb5_kt_get_name(context, keytab, name, MAX_KEYTAB_NAME_LEN);
	if (err)
                XSRETURN_UNDEF;
	RETVAL = sv_2mortal(newSVpv(name, 0));
        can_free((SV *)RETVAL);

#line 3214 "lib/Authen/Krb5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keytab_next_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_next_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keytab, cursor");
    {
	krb5_kt_cursor *	cursor;
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_kt_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_kt_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_kt_cursorPtr");
	}
;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;
#line 1153 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        err = krb5_kt_next_entry(context, keytab, RETVAL, cursor);
	if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3264 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::KeytabEntry", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keytab_remove_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_remove_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keytab, entry");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	entry;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;

	if (ST(1) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1169 "lib/Authen/Krb5.xs"
        err = krb5_kt_remove_entry(context, keytab, entry);
	if (err)
                XSRETURN_UNDEF;
	XSRETURN_YES;
#line 3314 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__Keytab_start_seq_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_start_seq_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keytab");
    {
	Authen__Krb5__Keytab	keytab;
	krb5_kt_cursor *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;
#line 1179 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_kt_cursor))
		XSRETURN_UNDEF;
        err = krb5_kt_start_seq_get(context, keytab, RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 3348 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "krb5_kt_cursorPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Keytab_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Keytab_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keytab");
    {
	Authen__Krb5__Keytab	keytab;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	}
;
#line 1193 "lib/Authen/Krb5.xs"
        if (keytab && should_free((SV *)keytab)) {
                krb5_kt_close(context, keytab);
                freed((SV *)keytab);
        }
#line 3385 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Authen__Krb5__KeytabEntry_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeytabEntry_new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, principal, vno, key");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	Authen__Krb5__Principal	principal;
	krb5_kvno	vno = (unsigned int)SvUV(ST(2))
;
	Authen__Krb5__Keyblock	key;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	}
;

	if (ST(3) == &PL_sv_undef) {
		key = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		key = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("key is not of type Authen::Krb5::Keyblock");
	}
;
#line 1208 "lib/Authen/Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        *RETVAL = keytab_entry_init;
	RETVAL->principal = principal;
	RETVAL->vno = vno;
        RETVAL->key = *key;

        can_free((SV *)RETVAL);

#line 3439 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::KeytabEntry", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeytabEntry_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeytabEntry_principal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "entry");
    {
	Authen__Krb5__KeytabEntry	entry;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1225 "lib/Authen/Krb5.xs"
        err = krb5_copy_principal(context, entry->principal, &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3478 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Principal", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeytabEntry_timestamp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeytabEntry_timestamp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "entry");
    {
	Authen__Krb5__KeytabEntry	entry;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1238 "lib/Authen/Krb5.xs"
        RETVAL = entry->timestamp;

#line 3515 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeytabEntry_kvno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeytabEntry_kvno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "entry");
    {
	Authen__Krb5__KeytabEntry	entry;
	krb5_kvno	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1248 "lib/Authen/Krb5.xs"
        RETVAL = entry->vno;

#line 3548 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__KeytabEntry_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__KeytabEntry_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "entry");
    {
	Authen__Krb5__KeytabEntry	entry;
	Authen__Krb5__Keyblock	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	}
;
#line 1258 "lib/Authen/Krb5.xs"
        err = krb5_copy_keyblock(context, &entry->key, &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3583 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Keyblock", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_starttime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_starttime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1273 "lib/Authen/Krb5.xs"
	if (!cred->times.starttime)
            cred->times.starttime = cred->times.authtime;
        RETVAL = cred->times.starttime;

#line 3622 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_authtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_authtime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1285 "lib/Authen/Krb5.xs"
	RETVAL = cred->times.authtime;

#line 3655 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_endtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_endtime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1295 "lib/Authen/Krb5.xs"
	RETVAL = cred->times.endtime;

#line 3688 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_renew_till); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_renew_till)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1305 "lib/Authen/Krb5.xs"
	RETVAL = cred->times.renew_till;

#line 3721 "lib/Authen/Krb5.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_server)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
#line 1315 "lib/Authen/Krb5.xs"
	krb5_error_code retval;
	char *sname;

#line 3741 "lib/Authen/Krb5.c"
	char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1319 "lib/Authen/Krb5.xs"
	retval = krb5_unparse_name(context, cred->server, &sname);
	if (retval) {
	    com_err("Authen::Krb5::Creds", retval, "while unparsing server name");
            return;
	}

	RETVAL = sname;

#line 3765 "lib/Authen/Krb5.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_client); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_client)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
#line 1335 "lib/Authen/Krb5.xs"
	krb5_error_code retval;
	char *name;

#line 3786 "lib/Authen/Krb5.c"
	char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1339 "lib/Authen/Krb5.xs"
	retval = krb5_unparse_name(context, cred->client, &name);
	if (retval) {
	    com_err("Authen::Krb5::Creds", retval, "while unparsing client name");
            return;
	}

	RETVAL = name;

#line 3810 "lib/Authen/Krb5.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_ticket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_ticket)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
#line 1355 "lib/Authen/Krb5.xs"
	krb5_error_code retval;
	krb5_ticket *t;

#line 3831 "lib/Authen/Krb5.c"
	Authen__Krb5__Ticket	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1359 "lib/Authen/Krb5.xs"
	if (!New(0,t,1,krb5_ticket)) XSRETURN_UNDEF;

	retval = krb5_decode_ticket(&cred->ticket, &t);

	RETVAL = t;

	can_free((SV *)RETVAL);

#line 3854 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Ticket", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_keyblock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_keyblock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cred");
    {
	Authen__Krb5__Creds	cred;
	Authen__Krb5__Keyblock	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cred = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cred = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("cred is not of type Authen::Krb5::Creds");
	}
;
#line 1375 "lib/Authen/Krb5.xs"
	RETVAL = &cred->keyblock;

        can_free((SV *)RETVAL);

#line 3892 "lib/Authen/Krb5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Authen::Krb5::Keyblock", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__Krb5__Creds_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__Krb5__Creds_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "creds");
    {
	Authen__Krb5__Creds	creds;

	if (ST(0) == &PL_sv_undef) {
		creds = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("creds is not of type Authen::Krb5::Creds");
	}
;
#line 1390 "lib/Authen/Krb5.xs"
        if (creds && should_free((SV *)creds)) {
                krb5_free_cred_contents(context, creds);
                free(creds);
                freed((SV *)creds);
        }
#line 3930 "lib/Authen/Krb5.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Authen__Krb5); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Authen__Krb5)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Authen::Krb5::constant", XS_Authen__Krb5_constant);
        newXS_deffile("Authen::Krb5::error", XS_Authen__Krb5_error);
        newXS_deffile("Authen::Krb5::init_context", XS_Authen__Krb5_init_context);
        newXS_deffile("Authen::Krb5::free_context", XS_Authen__Krb5_free_context);
        newXS_deffile("Authen::Krb5::init_ets", XS_Authen__Krb5_init_ets);
        newXS_deffile("Authen::Krb5::get_default_realm", XS_Authen__Krb5_get_default_realm);
        newXS_deffile("Authen::Krb5::get_host_realm", XS_Authen__Krb5_get_host_realm);
        newXS_deffile("Authen::Krb5::build_principal_ext", XS_Authen__Krb5_build_principal_ext);
        newXS_deffile("Authen::Krb5::parse_name", XS_Authen__Krb5_parse_name);
        newXS_deffile("Authen::Krb5::sname_to_principal", XS_Authen__Krb5_sname_to_principal);
        newXS_deffile("Authen::Krb5::cc_resolve", XS_Authen__Krb5_cc_resolve);
        newXS_deffile("Authen::Krb5::cc_default_name", XS_Authen__Krb5_cc_default_name);
        newXS_deffile("Authen::Krb5::cc_default", XS_Authen__Krb5_cc_default);
        newXS_deffile("Authen::Krb5::kt_resolve", XS_Authen__Krb5_kt_resolve);
        newXS_deffile("Authen::Krb5::kt_default_name", XS_Authen__Krb5_kt_default_name);
        newXS_deffile("Authen::Krb5::kt_default", XS_Authen__Krb5_kt_default);
        newXS_deffile("Authen::Krb5::kt_read_service_key", XS_Authen__Krb5_kt_read_service_key);
        newXS_deffile("Authen::Krb5::get_init_creds_password", XS_Authen__Krb5_get_init_creds_password);
        newXS_deffile("Authen::Krb5::get_init_creds_keytab", XS_Authen__Krb5_get_init_creds_keytab);
        newXS_deffile("Authen::Krb5::get_in_tkt_with_password", XS_Authen__Krb5_get_in_tkt_with_password);
        newXS_deffile("Authen::Krb5::get_in_tkt_with_keytab", XS_Authen__Krb5_get_in_tkt_with_keytab);
        newXS_deffile("Authen::Krb5::mk_req", XS_Authen__Krb5_mk_req);
        newXS_deffile("Authen::Krb5::rd_req", XS_Authen__Krb5_rd_req);
        newXS_deffile("Authen::Krb5::gen_portaddr", XS_Authen__Krb5_gen_portaddr);
        newXS_deffile("Authen::Krb5::genaddrs", XS_Authen__Krb5_genaddrs);
        newXS_deffile("Authen::Krb5::gen_replay_name", XS_Authen__Krb5_gen_replay_name);
        newXS_deffile("Authen::Krb5::mk_priv", XS_Authen__Krb5_mk_priv);
        newXS_deffile("Authen::Krb5::rd_priv", XS_Authen__Krb5_rd_priv);
        newXS_deffile("Authen::Krb5::get_server_rcache", XS_Authen__Krb5_get_server_rcache);
        newXS_deffile("Authen::Krb5::sendauth", XS_Authen__Krb5_sendauth);
        newXS_deffile("Authen::Krb5::recvauth", XS_Authen__Krb5_recvauth);
        newXS_deffile("Authen::Krb5::Principal::realm", XS_Authen__Krb5__Principal_realm);
        newXS_deffile("Authen::Krb5::Principal::type", XS_Authen__Krb5__Principal_type);
        newXS_deffile("Authen::Krb5::Principal::data", XS_Authen__Krb5__Principal_data);
        newXS_deffile("Authen::Krb5::Principal::DESTROY", XS_Authen__Krb5__Principal_DESTROY);
        newXS_deffile("Authen::Krb5::Ccache::initialize", XS_Authen__Krb5__Ccache_initialize);
        newXS_deffile("Authen::Krb5::Ccache::store_cred", XS_Authen__Krb5__Ccache_store_cred);
        newXS_deffile("Authen::Krb5::Ccache::get_name", XS_Authen__Krb5__Ccache_get_name);
        newXS_deffile("Authen::Krb5::Ccache::get_principal", XS_Authen__Krb5__Ccache_get_principal);
        newXS_deffile("Authen::Krb5::Ccache::destroy", XS_Authen__Krb5__Ccache_destroy);
        newXS_deffile("Authen::Krb5::Ccache::start_seq_get", XS_Authen__Krb5__Ccache_start_seq_get);
        newXS_deffile("Authen::Krb5::Ccache::next_cred", XS_Authen__Krb5__Ccache_next_cred);
        newXS_deffile("Authen::Krb5::Ccache::end_seq_get", XS_Authen__Krb5__Ccache_end_seq_get);
        newXS_deffile("Authen::Krb5::Ccache::DESTROY", XS_Authen__Krb5__Ccache_DESTROY);
        newXS_deffile("Authen::Krb5::KeyBlock::length", XS_Authen__Krb5__KeyBlock_length);
        newXS_deffile("Authen::Krb5::KeyBlock::contents", XS_Authen__Krb5__KeyBlock_contents);
        newXS_deffile("Authen::Krb5::KeyBlock::enctype", XS_Authen__Krb5__KeyBlock_enctype);
        newXS_deffile("Authen::Krb5::KeyBlock::enctype_string", XS_Authen__Krb5__KeyBlock_enctype_string);
        newXS_deffile("Authen::Krb5::KeyBlock::DESTROY", XS_Authen__Krb5__KeyBlock_DESTROY);
        newXS_deffile("Authen::Krb5::AuthContext::new", XS_Authen__Krb5__AuthContext_new);
        newXS_deffile("Authen::Krb5::AuthContext::getflags", XS_Authen__Krb5__AuthContext_getflags);
        newXS_deffile("Authen::Krb5::AuthContext::setflags", XS_Authen__Krb5__AuthContext_setflags);
        newXS_deffile("Authen::Krb5::AuthContext::getrcache", XS_Authen__Krb5__AuthContext_getrcache);
        newXS_deffile("Authen::Krb5::AuthContext::setrcache", XS_Authen__Krb5__AuthContext_setrcache);
        newXS_deffile("Authen::Krb5::AuthContext::getaddrs", XS_Authen__Krb5__AuthContext_getaddrs);
        newXS_deffile("Authen::Krb5::AuthContext::setaddrs", XS_Authen__Krb5__AuthContext_setaddrs);
        newXS_deffile("Authen::Krb5::AuthContext::setports", XS_Authen__Krb5__AuthContext_setports);
        newXS_deffile("Authen::Krb5::AuthContext::getkey", XS_Authen__Krb5__AuthContext_getkey);
        newXS_deffile("Authen::Krb5::AuthContext::DESTROY", XS_Authen__Krb5__AuthContext_DESTROY);
        newXS_deffile("Authen::Krb5::Ticket::server", XS_Authen__Krb5__Ticket_server);
        newXS_deffile("Authen::Krb5::Ticket::enc_part2", XS_Authen__Krb5__Ticket_enc_part2);
        newXS_deffile("Authen::Krb5::Ticket::DESTROY", XS_Authen__Krb5__Ticket_DESTROY);
        newXS_deffile("Authen::Krb5::EncTktPart::client", XS_Authen__Krb5__EncTktPart_client);
        newXS_deffile("Authen::Krb5::EncTktPart::DESTROY", XS_Authen__Krb5__EncTktPart_DESTROY);
        newXS_deffile("Authen::Krb5::Address::new", XS_Authen__Krb5__Address_new);
        newXS_deffile("Authen::Krb5::Address::DESTROY", XS_Authen__Krb5__Address_DESTROY);
        newXS_deffile("Authen::Krb5::Keyblock::enctype", XS_Authen__Krb5__Keyblock_enctype);
        newXS_deffile("Authen::Krb5::Keyblock::length", XS_Authen__Krb5__Keyblock_length);
        newXS_deffile("Authen::Krb5::Keyblock::contents", XS_Authen__Krb5__Keyblock_contents);
        newXS_deffile("Authen::Krb5::Keyblock::DESTROY", XS_Authen__Krb5__Keyblock_DESTROY);
        newXS_deffile("Authen::Krb5::Keytab::add_entry", XS_Authen__Krb5__Keytab_add_entry);
        newXS_deffile("Authen::Krb5::Keytab::end_seq_get", XS_Authen__Krb5__Keytab_end_seq_get);
        newXS_deffile("Authen::Krb5::Keytab::get_entry", XS_Authen__Krb5__Keytab_get_entry);
        newXS_deffile("Authen::Krb5::Keytab::get_name", XS_Authen__Krb5__Keytab_get_name);
        newXS_deffile("Authen::Krb5::Keytab::next_entry", XS_Authen__Krb5__Keytab_next_entry);
        newXS_deffile("Authen::Krb5::Keytab::remove_entry", XS_Authen__Krb5__Keytab_remove_entry);
        newXS_deffile("Authen::Krb5::Keytab::start_seq_get", XS_Authen__Krb5__Keytab_start_seq_get);
        newXS_deffile("Authen::Krb5::Keytab::DESTROY", XS_Authen__Krb5__Keytab_DESTROY);
        newXS_deffile("Authen::Krb5::KeytabEntry::new", XS_Authen__Krb5__KeytabEntry_new);
        newXS_deffile("Authen::Krb5::KeytabEntry::principal", XS_Authen__Krb5__KeytabEntry_principal);
        newXS_deffile("Authen::Krb5::KeytabEntry::timestamp", XS_Authen__Krb5__KeytabEntry_timestamp);
        newXS_deffile("Authen::Krb5::KeytabEntry::kvno", XS_Authen__Krb5__KeytabEntry_kvno);
        newXS_deffile("Authen::Krb5::KeytabEntry::key", XS_Authen__Krb5__KeytabEntry_key);
        newXS_deffile("Authen::Krb5::Creds::starttime", XS_Authen__Krb5__Creds_starttime);
        newXS_deffile("Authen::Krb5::Creds::authtime", XS_Authen__Krb5__Creds_authtime);
        newXS_deffile("Authen::Krb5::Creds::endtime", XS_Authen__Krb5__Creds_endtime);
        newXS_deffile("Authen::Krb5::Creds::renew_till", XS_Authen__Krb5__Creds_renew_till);
        newXS_deffile("Authen::Krb5::Creds::server", XS_Authen__Krb5__Creds_server);
        newXS_deffile("Authen::Krb5::Creds::client", XS_Authen__Krb5__Creds_client);
        newXS_deffile("Authen::Krb5::Creds::ticket", XS_Authen__Krb5__Creds_ticket);
        newXS_deffile("Authen::Krb5::Creds::keyblock", XS_Authen__Krb5__Creds_keyblock);
        newXS_deffile("Authen::Krb5::Creds::DESTROY", XS_Authen__Krb5__Creds_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

